
/* Tabela ERROAVISONF: Erro e Aviso do Fechamento de NF(Nota Fiscal) */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ERROAVISONF */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Erro e Aviso do Fechamento de NF(Nota Fiscal),
             utilizando a tabela Geral de Logs de Operaes */


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_ERROAVISONF' AND
                 TYPE = 'TR' 		                AND
	              U.UID = O.UID                   AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_ERROAVISONF
GO

CREATE TRIGGER LOG_FIS_ERROAVISONF
ON ERROAVISONF
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(40);
   DECLARE  @V_DESC      VARCHAR(300);
   DECLARE  @V_DTOPER    DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO      VARCHAR(1);
   DECLARE  @V_IDERROAVISO_OLD VARCHAR(1);
   DECLARE  @V_CDERROAVISO_OLD VARCHAR(4);
   DECLARE  @V_IDERROAVISO_NEW VARCHAR(1);
   DECLARE  @V_CDERROAVISO_NEW VARCHAR(4);
BEGIN
   SET @V_TIPO         = '0';
   SET @V_DESC         = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSORp CURSOR FOR
   SELECT
      'U' IDCOMANDO,
      DELETED.IDERROAVISO,
      DELETED.CDERROAVISO,
      INSERTED.IDERROAVISO,
      INSERTED.CDERROAVISO

   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDERROAVISO  = DELETED.CDERROAVISO;

   OPEN C_CURSORp;
   FETCH NEXT FROM C_CURSORp INTO @V_ID_COMANDO,
                                 @V_IDERROAVISO_OLD,
                                 @V_CDERROAVISO_OLD,
                                 @V_IDERROAVISO_NEW,
                                 @V_CDERROAVISO_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_ID_COMANDO = 'D' /*DELETING*/BEGIN
         SET @V_TIPO = '3';
         IF @V_IDERROAVISO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Identificador Erro/Aviso = '    + @V_IDERROAVISO_OLD;
         END;
         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_CDERROAVISO_OLD;
      END
      ELSE IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (@V_IDERROAVISO_OLD <> @V_IDERROAVISO_NEW) BEGIN
             SET @V_TIPO   = '2';
             SET @V_ITPESQ = @V_CDERROAVISO_OLD;
         END;
      END
      ELSE BEGIN  /*INSERTING*/
        SET @V_TIPO   = '1';
        SET @V_ITPESQ = @V_CDERROAVISO_NEW;
      END;
      IF @V_IDERROAVISO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Identificador Erro/Aviso = '    + @V_IDERROAVISO_NEW;
      END;
      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                  IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('ERROAVISONF',  @V_DTOPER, @V_USUARIO,
                  @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSORp INTO @V_ID_COMANDO,
                                    @V_IDERROAVISO_OLD,
                                    @V_CDERROAVISO_OLD,
                                    @V_IDERROAVISO_NEW,
                                    @V_CDERROAVISO_NEW;

   END;
   CLOSE      C_CURSORp;
   DEALLOCATE C_CURSORp;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_ERROAVISONF','4.11.105';
GO

